"""
This file is automatically generated. Do not modify it manually.
"""

from .base_api_module import BaseApiModule


class AssessmentTypesApiModule(BaseApiModule):
    def list(self, params=None, **kwargs):
        """
        Returns an array assessment types.

        :param dict params: limit: integer
        offset: integer
        ordering: string

        :returns: properties:
          count:
            type: integer
          next:
            format: uri
            nullable: true
            type: string
          previous:
            format: uri
            nullable: true
            type: string
          results:
            items:
              $ref: '#/components/schemas/AssessmentType'
            type: array
        required:
        - count
        - results
        type: object

        https://docs.huvrdata.app/reference/api_assessment-types_list
        """
        return self.client.request(
            method="get",
            path=f"/api/assessment-types/",
            params=params,
            **kwargs,
        )

    def read(self, id, **kwargs):
        """
        Return the specific assessment type
        :params id Assessment ID

        :returns: $ref: '#/components/schemas/AssessmentType'

        https://docs.huvrdata.app/reference/api_assessment-types_read
        """
        return self.client.request(
            method="get",
            path=f"/api/assessment-types/{id}/",
            **kwargs,
        )
