"""
This file is automatically generated. Do not modify it manually.
"""

from .base_api_module import BaseApiModule


class AssetTypesApiModule(BaseApiModule):
    def list(self, params=None, **kwargs):
        """
        Returns an array asset types.

        :param dict params: is_active: string
        limit: integer
        name: string
        offset: integer
        ordering: string

        :returns: properties:
          count:
            type: integer
          next:
            format: uri
            nullable: true
            type: string
          previous:
            format: uri
            nullable: true
            type: string
          results:
            items:
              $ref: '#/components/schemas/AssetType'
            type: array
        required:
        - count
        - results
        type: object

        https://docs.huvrdata.app/reference/api_asset-types_list
        """
        return self.client.request(
            method="get",
            path=f"/api/asset-types/",
            params=params,
            **kwargs,
        )

    def create(self, json=None, **kwargs):
        """
        Asset Type endpoint


        :param dict json: $ref: '#/components/requestBodies/AssetType'

        :returns: $ref: '#/components/schemas/AssetType'

        https://docs.huvrdata.app/reference/api_asset-types_create
        """
        return self.client.request(
            method="post",
            path=f"/api/asset-types/",
            json=json,
            **kwargs,
        )

    def read(self, id, **kwargs):
        """
        Return the specific asset type
        :params id asset ID

        :returns: $ref: '#/components/schemas/AssetType'

        https://docs.huvrdata.app/reference/api_asset-types_read
        """
        return self.client.request(
            method="get",
            path=f"/api/asset-types/{id}/",
            **kwargs,
        )

    def update(self, id, json=None, **kwargs):
        """
        AssetType updates

        :param dict json: $ref: '#/components/requestBodies/AssetType'

        :returns: $ref: '#/components/schemas/AssetType'

        https://docs.huvrdata.app/reference/api_asset-types_update
        """
        return self.client.request(
            method="put",
            path=f"/api/asset-types/{id}/",
            json=json,
            **kwargs,
        )

    def partial_update(self, id, json=None, **kwargs):
        """
        Asset Type endpoint


        :param dict json: $ref: '#/components/requestBodies/AssetType'

        :returns: $ref: '#/components/schemas/AssetType'

        https://docs.huvrdata.app/reference/api_asset-types_partial_update
        """
        return self.client.request(
            method="patch",
            path=f"/api/asset-types/{id}/",
            json=json,
            **kwargs,
        )

    def delete(self, id, **kwargs):
        """
        Asset Type endpoint

        https://docs.huvrdata.app/reference/api_asset-types_delete
        """
        return self.client.request(
            method="delete",
            path=f"/api/asset-types/{id}/",
            **kwargs,
        )
