"""
This file is automatically generated. Do not modify it manually.
"""

from .base_api_module import BaseApiModule


class ChecklistTasksApiModule(BaseApiModule):
    def list(self, params=None, **kwargs):
        """
        Returns an array of ChecklistTasks.

        :param dict params: assigned: string
        assigned_to: string
        checklist: string
        done: string
        limit: integer
        offset: integer
        ordering: string
        project: string
        task: string

        :returns: properties:
          count:
            type: integer
          next:
            format: uri
            nullable: true
            type: string
          previous:
            format: uri
            nullable: true
            type: string
          results:
            items:
              $ref: '#/components/schemas/ChecklistTask'
            type: array
        required:
        - count
        - results
        type: object

        https://docs.huvrdata.app/reference/api_checklist-tasks_list
        """
        return self.client.request(
            method="get",
            path=f"/api/checklist-tasks/",
            params=params,
            **kwargs,
        )

    def create(self, json=None, **kwargs):
        """
        View Checklist Task


        :param dict json: $ref: '#/components/requestBodies/ChecklistTaskCreate'

        :returns: $ref: '#/components/schemas/ChecklistTask'

        https://docs.huvrdata.app/reference/api_checklist-tasks_create
        """
        return self.client.request(
            method="post",
            path=f"/api/checklist-tasks/",
            json=json,
            **kwargs,
        )

    def read(self, id, **kwargs):
        """
        Return the specific Checklist Task
        :params id

        :returns: $ref: '#/components/schemas/ChecklistTask'

        https://docs.huvrdata.app/reference/api_checklist-tasks_read
        """
        return self.client.request(
            method="get",
            path=f"/api/checklist-tasks/{id}/",
            **kwargs,
        )

    def update(self, id, json=None, **kwargs):
        """
        View Checklist Task


        :param dict json: $ref: '#/components/requestBodies/ChecklistTaskCreate'

        :returns: $ref: '#/components/schemas/ChecklistTask'

        https://docs.huvrdata.app/reference/api_checklist-tasks_update
        """
        return self.client.request(
            method="put",
            path=f"/api/checklist-tasks/{id}/",
            json=json,
            **kwargs,
        )

    def partial_update(self, id, json=None, **kwargs):
        """
        View Checklist Task


        :param dict json: $ref: '#/components/requestBodies/ChecklistTaskCreate'

        :returns: $ref: '#/components/schemas/ChecklistTaskCreate'

        https://docs.huvrdata.app/reference/api_checklist-tasks_partial_update
        """
        return self.client.request(
            method="patch",
            path=f"/api/checklist-tasks/{id}/",
            json=json,
            **kwargs,
        )

    def delete(self, id, **kwargs):
        """
        View Checklist Task

        https://docs.huvrdata.app/reference/api_checklist-tasks_delete
        """
        return self.client.request(
            method="delete",
            path=f"/api/checklist-tasks/{id}/",
            **kwargs,
        )
