"""
This file is automatically generated. Do not modify it manually.
"""

from .base_api_module import BaseApiModule


class DefectProfilesApiModule(BaseApiModule):
    def list(self, params=None, **kwargs):
        """
        Returns an array of defect profiles.

        :param dict params: limit: integer
        offset: integer
        ordering: string

        :returns: properties:
          count:
            type: integer
          next:
            format: uri
            nullable: true
            type: string
          previous:
            format: uri
            nullable: true
            type: string
          results:
            items:
              $ref: '#/components/schemas/DefectProfile'
            type: array
        required:
        - count
        - results
        type: object

        https://docs.huvrdata.app/reference/api_defect-profiles_list
        """
        return self.client.request(
            method="get",
            path=f"/api/defect-profiles/",
            params=params,
            **kwargs,
        )

    def create(self, json=None, **kwargs):
        """
        View DefectProfile


        :param dict json: $ref: '#/components/requestBodies/DefectProfile'

        :returns: $ref: '#/components/schemas/DefectProfile'

        https://docs.huvrdata.app/reference/api_defect-profiles_create
        """
        return self.client.request(
            method="post",
            path=f"/api/defect-profiles/",
            json=json,
            **kwargs,
        )

    def read(self, id, **kwargs):
        """
        Return the specific Defect Profile
        :params id

        :returns: $ref: '#/components/schemas/DefectProfile'

        https://docs.huvrdata.app/reference/api_defect-profiles_read
        """
        return self.client.request(
            method="get",
            path=f"/api/defect-profiles/{id}/",
            **kwargs,
        )

    def update(self, id, json=None, **kwargs):
        """
        View DefectProfile


        :param dict json: $ref: '#/components/requestBodies/DefectProfile'

        :returns: $ref: '#/components/schemas/DefectProfile'

        https://docs.huvrdata.app/reference/api_defect-profiles_update
        """
        return self.client.request(
            method="put",
            path=f"/api/defect-profiles/{id}/",
            json=json,
            **kwargs,
        )

    def partial_update(self, id, json=None, **kwargs):
        """
        View DefectProfile


        :param dict json: $ref: '#/components/requestBodies/DefectProfile'

        :returns: $ref: '#/components/schemas/DefectProfile'

        https://docs.huvrdata.app/reference/api_defect-profiles_partial_update
        """
        return self.client.request(
            method="patch",
            path=f"/api/defect-profiles/{id}/",
            json=json,
            **kwargs,
        )

    def delete(self, id, **kwargs):
        """
        View DefectProfile

        https://docs.huvrdata.app/reference/api_defect-profiles_delete
        """
        return self.client.request(
            method="delete",
            path=f"/api/defect-profiles/{id}/",
            **kwargs,
        )
