"""
This file is automatically generated. Do not modify it manually.
"""

from .base_api_module import BaseApiModule


class ReservationsApiModule(BaseApiModule):
    def list(self, params=None, **kwargs):
        """
        Returns an array reservations.

        :param dict params: limit: integer
        offset: integer
        ordering: string

        :returns: properties:
          count:
            type: integer
          next:
            format: uri
            nullable: true
            type: string
          previous:
            format: uri
            nullable: true
            type: string
          results:
            items:
              $ref: '#/components/schemas/Reservation'
            type: array
        required:
        - count
        - results
        type: object

        https://docs.huvrdata.app/reference/api_reservations_list
        """
        return self.client.request(
            method="get",
            path=f"/api/reservations/",
            params=params,
            **kwargs,
        )

    def create(self, json=None, **kwargs):
        """
        accept a flat object for create, return nested detail object

        :param dict json: $ref: '#/components/schemas/ReservationCreate'

        :returns: $ref: '#/components/schemas/Reservation'

        https://docs.huvrdata.app/reference/api_reservations_create
        """
        return self.client.request(
            method="post",
            path=f"/api/reservations/",
            json=json,
            **kwargs,
        )

    def states(self, params=None, **kwargs):
        """
        return a list reservation enums

        :param dict params: limit: integer
        offset: integer
        ordering: string

        :returns: properties:
          count:
            type: integer
          next:
            format: uri
            nullable: true
            type: string
          previous:
            format: uri
            nullable: true
            type: string
          results:
            items:
              $ref: '#/components/schemas/Reservation'
            type: array
        required:
        - count
        - results
        type: object

        https://docs.huvrdata.app/reference/api_reservations_states
        """
        return self.client.request(
            method="get",
            path=f"/api/reservations/states/",
            params=params,
            **kwargs,
        )

    def read(self, id, **kwargs):
        """
        Return the specific Reservation
        :params id Reservation ID

        :returns: $ref: '#/components/schemas/Reservation'

        https://docs.huvrdata.app/reference/api_reservations_read
        """
        return self.client.request(
            method="get",
            path=f"/api/reservations/{id}/",
            **kwargs,
        )

    def update(self, id, json=None, **kwargs):
        """
        Reservation update and add reservation history

        :param dict json: $ref: '#/components/requestBodies/ReservationUpdate'

        :returns: $ref: '#/components/schemas/Reservation'

        https://docs.huvrdata.app/reference/api_reservations_update
        """
        return self.client.request(
            method="put",
            path=f"/api/reservations/{id}/",
            json=json,
            **kwargs,
        )

    def partial_update(self, id, json=None, **kwargs):
        """
        View reservations


        :param dict json: $ref: '#/components/requestBodies/ReservationUpdate'

        :returns: $ref: '#/components/schemas/ReservationUpdate'

        https://docs.huvrdata.app/reference/api_reservations_partial_update
        """
        return self.client.request(
            method="patch",
            path=f"/api/reservations/{id}/",
            json=json,
            **kwargs,
        )

    def delete(self, id, **kwargs):
        """
        View reservations

        https://docs.huvrdata.app/reference/api_reservations_delete
        """
        return self.client.request(
            method="delete",
            path=f"/api/reservations/{id}/",
            **kwargs,
        )
